#include <stdio.h>
#include <string.h>

#include "gen.h"
#include "bitv.h"

void bitInit(bitvec_t *vec, int members)
{
  memset(vec->vec, 0, N);
  vec->count = 0;
  vec->members = members;
}

void bitSet(bitvec_t *vec, int bitPos)
{
  if (!bitIsSet(vec, bitPos)) {
    vec->vec[bitPos] = 1;
    (vec->count)++;
  }
}

void bitClear(bitvec_t *vec, int bitPos)
{
  vec->vec[bitPos] = 0;
  (vec->count)--;
}

boolean bitIsSet(bitvec_t *vec, int bitPos)
{
  return (vec->vec[bitPos] ? TRUE : FALSE);
}

void bitPrint(bitvec_t *vec)
{
  int          i;

  for (i = 0; i < vec->members; i++) {
    if (vec->vec[i])
      printf("%d ", i);
  }
  printf("\n");

  return;
}
