#ifndef __DOMSET_H
#define __DOMSET_H

typedef struct DS_s {
  int        nodeId;
  int        domN;
  int       *domSet;
} DS_t;

typedef struct domSet_s {
  int        DSsize;
  DS_t       DS[N];
} domSet_t;

/* Initialise the given domSet                                */
void domSetInit(domSet_t *set);

/* Check if the given nodeId is a member of the domSet.       */
/* Returns the index in the set on success and -1 on error.   */
int domSetMember(domSet_t *set, int nodeId);

/* Add the nodeId to the given domSet                         */
void domSetAdd(domSet_t *set, int nodeId);

/* Add the set of nodes 'domIDs' as the dominated nodes of    */
/* the given nodeId in the domSet                             */
void domSetAddMember(domSet_t *set, int nodeId, int domNodes, int *domIDs);

#endif /* __DOMSET_H */

