#ifndef __SET_H
#define __SET_H

typedef struct nodeSet_s {
  int   size;
  int   set[N];
} nodeSet;

/* Initialize the nodeSet                                             */
void initNodeSet(nodeSet *S);

/* Add a new node to the set of nodes                                 */
void addNodetoNodeSet(int nodeId, nodeSet *S);

/* Print the set of nodes (for debug purposes only)                   */
void printNodeSet(nodeSet *S);

/* Function to create a copy of the node set                          */
void copyNodeSet(nodeSet *dest, nodeSet *src);

/* If nodeId is a member of the given set, return TRUE; else FALSE    */
boolean isSetMember(int nodeId, nodeSet *S);

/* Function that returns TRUE if two sets are equal; FALSE otherwise  */
boolean setEqual(nodeSet *S1, nodeSet *S2);

/* Function that returns TRUE if set S2 is a subset of set S1;        */
/* FALSE otherwise                                                    */
boolean setSubset(nodeSet *S1, nodeSet *S2);

/* Function to delete a given node from the given set of nodes        */
void delNodefromNodeSet(int nodeId, nodeSet *from);

/* Function for union of two sets; result is stored in first argument */
void setUnion(nodeSet *V1, nodeSet *V2);

/* Function to calculate the intersection of two node sets            */
void setIntersect(nodeSet *V1, nodeSet *V2, nodeSet *out);

/* V1 - V2 with the result in V1 */
void setDifference(nodeSet *V1, nodeSet *V2);

/* Function for difference of two sets; result is stored in V3        */
void setDiff(nodeSet *V1, nodeSet *V2, nodeSet *V3);

#endif /* __SET_H */
